from dropshipping.utils.price_finders import OfferServiceLowestOfferListingPriceFinder, OfferServiceBuyBoxPriceFinder
from dropshipping.utils.offer_services import EsLowestOfferListingOfferService, EsBuyBoxOfferService, ScrapyLowestOfferListingOfferService
from dropshipping.utils.offer_converters import EsLowestOfferListingOfferConverter, EsBuyBoxOfferConverter
from dropshipping.utils.offer_filters import LowestOfferListingOfferFilter, BuyBoxOfferFilter


def lowest_price_finder_test():
    provider = {}
    offer_filter = LowestOfferListingOfferFilter({
        'feedback': 70,
        'rating': 90,
        # 'domestic': True,
        'shipping_time': 4,
        'subcondition': 70,
        'fba': None,
        'offers': 1,
        'picked_count': 1,
        'provider_type': max,
        'price': None,
        'expire_hour': 300
    }, {'subcondition_strategy': 'ge'})

    offer_service = EsLowestOfferListingOfferService(host='35.245.123.47', port=80, user='elasticuser',
                                                     password='KbersRiseUp153')
    offer_converter = EsLowestOfferListingOfferConverter()
    price_finder = OfferServiceLowestOfferListingPriceFinder(offer_filter, offer_service, offer_converter)
    asins = [
        '3466345650',
    ]
    source_offer = price_finder.find_offer_for_asins(asins, 'de', 'used')
    print(source_offer)


def buybox_price_finder_test():
    provider = {}
    buybox_offer_filter = BuyBoxOfferFilter(
        {'condition': 'Used', 'expire_hour': 24})

    offer_service = EsBuyBoxOfferService(host='35.245.123.47', port=80, user='elasticuser', password='KbersRiseUp153')
    offer_converter = EsBuyBoxOfferConverter()
    price_finder = OfferServiceBuyBoxPriceFinder(buybox_offer_filter, offer_service, offer_converter)
    asins = [
        'B01FIYR712',
    ]
    source_offers = price_finder.find_offer_for_asins(asins, 'us', 'used')
    print(source_offers)


if __name__ == '__main__':
    lowest_price_finder_test()
